<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTicketing.Presale ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTicketing.Presale
 * @subpackage Arrays
 */
class ArrayOfTicketing_Presale extends AbstractStructArrayBase
{
    /**
     * The Ticketing_Presale
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\Ticketing_Presale[]
     */
    public $Ticketing_Presale;
    /**
     * Constructor method for ArrayOfTicketing.Presale
     * @uses ArrayOfTicketing_Presale::setTicketing_Presale()
     * @param \patest\StructType\Ticketing_Presale[] $ticketing_Presale
     */
    public function __construct(array $ticketing_Presale = array())
    {
        $this
            ->setTicketing_Presale($ticketing_Presale);
    }
    /**
     * Get Ticketing_Presale value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\Ticketing_Presale[]|null
     */
    public function getTicketing_Presale()
    {
        return isset($this->{'Ticketing.Presale'}) ? $this->{'Ticketing.Presale'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTicketing_Presale method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTicketing_Presale method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTicketing_PresaleForArrayConstraintsFromSetTicketing_Presale(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTicketing_PresaleTicketing_PresaleItem) {
            // validation for constraint: itemType
            if (!$arrayOfTicketing_PresaleTicketing_PresaleItem instanceof \patest\StructType\Ticketing_Presale) {
                $invalidValues[] = is_object($arrayOfTicketing_PresaleTicketing_PresaleItem) ? get_class($arrayOfTicketing_PresaleTicketing_PresaleItem) : sprintf('%s(%s)', gettype($arrayOfTicketing_PresaleTicketing_PresaleItem), var_export($arrayOfTicketing_PresaleTicketing_PresaleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Ticketing_Presale property can only contain items of type \patest\StructType\Ticketing_Presale, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Ticketing_Presale value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\Ticketing_Presale[] $ticketing_Presale
     * @return \patest\ArrayType\ArrayOfTicketing_Presale
     */
    public function setTicketing_Presale(array $ticketing_Presale = array())
    {
        // validation for constraint: array
        if ('' !== ($ticketing_PresaleArrayErrorMessage = self::validateTicketing_PresaleForArrayConstraintsFromSetTicketing_Presale($ticketing_Presale))) {
            throw new \InvalidArgumentException($ticketing_PresaleArrayErrorMessage, __LINE__);
        }
        if (is_null($ticketing_Presale) || (is_array($ticketing_Presale) && empty($ticketing_Presale))) {
            unset($this->Ticketing_Presale, $this->{'Ticketing.Presale'});
        } else {
            $this->Ticketing_Presale = $this->{'Ticketing.Presale'} = $ticketing_Presale;
        }
        return $this;
    }
    /**
     * Add item to Ticketing_Presale value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\Ticketing_Presale $item
     * @return \patest\ArrayType\ArrayOfTicketing_Presale
     */
    public function addToTicketing_Presale(\patest\StructType\Ticketing_Presale $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\Ticketing_Presale) {
            throw new \InvalidArgumentException(sprintf('The Ticketing_Presale property can only contain items of type \patest\StructType\Ticketing_Presale, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Ticketing_Presale[] = $this->{'Ticketing.Presale'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\Ticketing_Presale|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\Ticketing_Presale|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\Ticketing_Presale|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\Ticketing_Presale|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\Ticketing_Presale|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Ticketing.Presale
     */
    public function getAttributeName()
    {
        return 'Ticketing.Presale';
    }
}
